#!/usr/bin/perl -w

=head1 NAME

B<Regexp::Common::Fast> - 

=head1 SYNOPSIS

 use Regexp::Common qw/ your params here /;
 use Regexp::Common::Fast;

 ### _S_L_O_W_ ### Regexp::Common's syntax
 $re	=  $RE{num}{int};
 $data	=~ /$RE{num}{int}{-sep=>','}{-keep}/;

 ### _F_A_S_T_ ### Regexp::Common::Fast's syntax
 $re	=  "\R[num,int]";
 $data	=~ /\R[num,int,-sep=>',',-keep]/;

=head1 DESCRIPTION


=cut

package Regexp::Common::Fast;

#use strict;
#no strict 'subs'; # Bareword "Apache" not allowed: "$RE{x}{-word=>Apache}"

use Filter::Simple;

our $VERSION = "1.01";

my ($ID, %ID);

# TODO     $Regexp::Common::RE{...}
#  $RE{...}
# BUG FIXME        
my $param = qr/(?:[^,'"\]]+|'[^']*'|"[^"]*")+/;
sub filter {
    s/\\R\[($param(?:,$param)*)\]/
	my $p = $1;
	unless ($ID{$p}) {
	    (my $keys="{$p}") =~ s!($param),!$1}{!g;
	    $keys =~ s!{([^"'][^'"=}]*)!{'$1'!g;
	    ${"RE_CACHE_".($ID{$p}=++$ID)} = eval "\$Regexp::Common::RE$keys";
	}
	"\${Regexp::Common::Fast::RE_CACHE_" . $ID{$p} . "}";
    /ge
}

FILTER \&filter;

=head1 HISTORY

 1.01		   6 01:07:25 EEST 2003
      - fixed bug in "\R[...]alphanum_here"

 1.00		  18 19:58:09 EET 2003
      - no comments

=head1 AUTHOR

Alex Efros <powerman@asdfGroup.com>

=cut

